      program DERIV                                                            
c                                                                               
c this simple program computes the first derivative of a function  
c using the second and fourth order accurate schemes. the following
c driver estimates the derivatives of  p(z) = po*exp(-a*z)                                         
c                                                                               
      parameter(l=10)                                                          
      real z(l),p(l),p2(l),p4(l),anal(l)
c                                       
      data z /0000.,1000.,2000.,3000.,4000.,                                       
     &         5000.,6000.,7000.,8000.,9000./                                    
      data a,p0,dz/0.000125062,1000.,1000./
c
c  initialize the work arrays
c
      do 2100 k = 1, l
         p2(k)  = 0.
         p4(k)  = 0.
2100  continue
c                                  
      do 2102 k = 1, l
c                                                             
c  construct the function p(z)
c                                                 
      p(k)      =  p0*exp(-a*z(k))
c                                                   
c  compute the analytical derivative
c                                           
      anal(k)   = -a*p0*exp(-a*z(k))
c                                             
 2102 continue 
c                                                                
c  compute the second order estimate                                           
c
      call DDX2 (p,p2,l,dz,1)                                                   
c
c  compute the fourth order estimate                                           
c
      call DDX4 (p,p4,l,dz)
c
c  write output . The 4th order derivative is omitted at the first 
c  and last 2 points  since it is not defined as 4th order.
c                                                     
      write (6,1000)                                                           
      write (6,1001)
c                                                           
      do 2104 k = 1, l 
         if (k.le.2.or.k.ge.(l-1)) then                                                            
      write(6,1002) anal(k),   p2(k)
         else                                   
      write(6,1003) anal(k),   p2(k),  p4(k)
         endif                                   
 2104 continue
c                                                                 
1000  format (5x,'analytical',15x,'second order',13x,'fourth order')           
1001  format (5x,' solution ',15x,'  estimate  ',13x,'  estimate  ',/)         
1002  format (5x,f10.6,15x,f10.6)                                    
1003  format (5x,f10.6,15x,f10.6,15x,f10.6)                                    
      stop                                                                     
      end                                                                      
