      Program DIAGNOS
      parameter (l = 21,m = 13,np = 7 ,k = 1)
      real ug(l,m,np),vg(l,m,np),tg(l,m,np)
      real u(l,m,k),v(l,m,k),t(l,m,k)
      real zonav(m,k),areav (k),devzon(l,m,k),devaer(m,k)
      data gleft,gright,glat1,glat2/-25.,25.,-15.,15./
      data p ,del/500.,2.5/
c
c  Open input files .
c

      open (20,file='uv21.dat  ',status='old',readonly)
      open (30,file='temp21.dat',status='old',readonly)
c
c  Read from multilevel input data .
c
  15  format(10f8.2)
c
      do 13100 ip = 1, np
c
         read (20,15) ((ug(i,j,ip),i=1,l),j=1,m)
         read (20,15) ((vg(i,j,ip),i=1,l),j=1,m)
         read (30,15) ((tg(i,j,ip),i=1,l),j=1,m)
c         
13100 continue
c
c  Seletc data for 500 mb level for this example .
c  Data in multilevel files are arranged as : 
c  1000-850-700-500-300-200-100 mb
c
      do 13102 j  = 1 , m
      do 13102 i  = 1 , l
c      
         u(i,j,k) =  ug (i,j,4)  
         v(i,j,k) =  vg (i,j,4)  
         t(i,j,k) =  tg (i,j,4)
c           
13102 continue
c
c  Compute the zonal and area average of the
c  temperature .
c 
      call AVERAG1 (t,zonav,areav,gleft,gright,glat1,glat2,del)
c
c  Compute the deviation from the zonal average .
c
      call DEVIAT  (t,zonav,areav,devzon,devaer) 
c
c  Compute the eddy available potential energy
c  and the zonal available potential energy .
c
      call APEZANDE (t,p,az,as,gleft,gright,glat1,glat2,del)
c
c  Compute the eddy kinetic  energy and the 
c  zonal kinetic energy .Conversion of wind 
c  speed inot cgs units is done first .
c
      do 13104 j  = 1,  m
      do 13104 i  = 1,  l
c      
         u(i,j,1) = u(i,j,k)* 100.
         v(i,j,1) = v(i,j,k)* 100.
c      
13104 continue

      call KEZANDE (u,v,ekz,eke,gleft,gright,glat1,glat2,del)
c      
1000  format(21f8.2)
      stop
      end
c
