      program RADIA                                                              
c
c  This program estimates the longwave and shotwave 
c  radiative fluxes using the emissivity method .
c   CAUTION : On some machines this program needs
c   to be compiled with an option that initialize all
c   unitialized variables to zero.For most compilers
c   this procedure is the default . With Unix operating 
c   system that option is :
c       f77 -K filename.f
c                                                              
      parameter ( nk =1 2)                                                         
      parameter ( hz = 12.,day = 20,month = 12)                                        
      parameter (ilevv = 12,ilev2v = ilevv+2)                                       
      real irtop                                                                
      dimension t(nk),q(nk),sh(nk),s(nk),declsc(2)                              
      dimension rtrter(nk),rtrsol(nk)                                           
      common/wetc/eps,ae(2),be(2),ht(2),tc                                    
      common/rrr/ fup(ilev2v,8),fdw(ilev2v,8),rw(ilev2v)                       
     &,fx(ilev2v),tl(ilev2v),aso(ilev2v,8),rso(ilev2v,8)
     &,albc(8),rsa,secz,coe(8),dtc(ilev2v,8),fnet(ilev2v,8)
     &,cld(ilev2v,8),rhx(ilevv),dp(ilevv),qz(ilevv),p(ilev2v)
     &,tz(ilevv),dpz(ilev2v),qs(ilevv),sso(8),dtw(ilev2v,8)                                                            
c
c  Define the logical switches for radiation calls.
c                                                                                
      logical swc,swr                                                           
      data swr,swc /.true.,.true./ 
c
c  Define the grid distance in the x and y directions
c  and some other required constants.
c                                            
      data dphi,dlambda,stebol /5.5376,5.625,5.6678e-8 / 
c
c  Calculation are done on sigma levels .
c  sigma = p/ps .
c                                     
      data s /.1,.2,.3,.4,.5,.6,.7,.8,.85,.9,.95,.99/
c
      pi         = 3.14159                                                                              
      picon      = pi/180.                                                             
c
c  Open output file
c
      open (20,file='radia.out',status='unknown')
c                                                                                
c  Define temperature ,specific humidity for the 
c  vertical column.
c                                                                               
      data t/220.16,218.06,223.71,235.78,247.31,256.73,                         
     &       264.38,269.16,271.98,274.71,277.10,278.41/
c                         
       data q/ 4.0412000e-05,1.7426601e-05,2.6705300e-05                        
     &        ,9.5105803e-05,2.6963701e-04,6.8341498e-04                        
     &        ,1.6110500e-03,2.1570900e-03,2.3708199e-03                        
     &        ,2.5780201e-03,2.9228700e-03,3.2207901e-03/                       
c                                                                               
c  Define surface parameters. These variables are explained
c  in SIMFLX .                                                
c                                                                               
       data ts,ps /278.96,88230.5/                                               
       data rlong,sinlat,coslat,albedo/0.00,0.587,0.810,8.05e-02/               
       data vent/178.22/                                                        
c                                                                               
c  Compute declination angle from day and month
c
      call CONRAD (declsc,day,month)                                             
c
c  Compute intermediate sigma levels (sh)                           
c
      do 9100 k = 1, nk-1                                                           
         sh(k)  = sqrt ( s(k)*s(k+1) )                                       
 9100 continue                                                                  
      sh(nk)    = sqrt ( s(nk) )                                             
c
c  Compute Corilis parameter
c
      f         = 2.*7.29e-05*sinlat                                                     
c
c  Define moisture constants
c
      call WETCNS                                                                
c
c  Define the grid point position (not necessary for column model)
c
      ic        = 6                                                                      
      jc        = 7                                                                      
c
c  Call radiation routine
c
      call RAD (rtrsol,rtrter,flxvis,flxiri,ts,t,q,ps,sh,nk,                     
     &          rlong,sinlat,coslat,s,hz,albedo,vent,declsc,
     &                                  swr,swc,irtop,ic,jc)         
c                                                                               
c  Write output of shortwave and longwave heating at surface(Watt/m2)
c  and vertical profiles of the shortwave and longwave fluxes(deg/day)
c                                                                              
      fact      = 86400.
 1000 format(2x,2f12.4)
      print *,flxvis,flxiri                                                   
      do 9102 k = 1, nk                                                            
      write(20,1000)rtrsol(k)*fact,rtrter(k)*fact                               
 9102 continue                                                                 
      stop                                                                     
      end                                                                      
